//+------------------------------------------------------------------+
//|                                              TestCanvasLines.mq5 |
//|                                  Copyright 2022, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164


//+------------------------------------------------------------------+
int OnInit()
{
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{

}
//+------------------------------------------------------------------+
void OnTick()
{
   Draw();
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   if (id == CHARTEVENT_CHART_CHANGE) Draw();
}
//+------------------------------------------------------------------+
void Draw()
{
   static uint last = 0;
   uint cur = GetTickCount();
   if (cur-last<30) return;
   last = cur;
   if (Canvas.tester) ChartChanged();
   Canvas.Erase(0x00FFFFFF);
   double high[], low[];
   int right_bar = (int)W.Right_bar;
   int size = W.Left_bar-right_bar+1;
   CopyHigh(_Symbol,_Period,right_bar,size,high);
   CopyLow(_Symbol,_Period,right_bar,size,low);
   int max_i = ArrayMaximum(high);
   int min_i = ArrayMinimum(low);
   Canvas.LineThick((int)Canvas.X(double(size-1-max_i+right_bar)),(int)Canvas.Y(high[max_i]),(int)Canvas.X(double(size-1-min_i+right_bar)),(int)Canvas.Y(low[min_i]),0x809000FF,1,STYLE_DASHDOTDOT,LINE_END_ROUND);
   Canvas.Update();
}
//+------------------------------------------------------------------+
